package net.maunium.Maucros.Actions;

import java.util.List;

import net.maunium.Maucros.Config.Settings;
import net.maunium.Maucros.Config.Settings.Autoattack;

import net.minecraft.client.Minecraft;
import net.minecraft.client.entity.EntityPlayerSP;
import net.minecraft.client.multiplayer.PlayerControllerMP;
import net.minecraft.client.settings.KeyBinding;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumChatFormatting;
import net.minecraft.util.MovingObjectPosition;

public class ActionAutoattack extends DelayAction{
	public ActionAutoattack() {
		super("Autoattack");
	}

	@Override
	public void executeChecked() {
		EntityPlayerSP p = Minecraft.getMinecraft().thePlayer;
		PlayerControllerMP pc = Minecraft.getMinecraft().playerController;
		MovingObjectPosition moprt = p.rayTrace(pc.getBlockReachDistance(), 1);
		if (moprt != null && moprt.entityHit != null) pc.attackEntity(p, moprt.entityHit);
		else if (Minecraft.getMinecraft().playerController.isInCreativeMode() && moprt != null && moprt.hitVec != null && moprt.sideHit != null) {
			pc.func_180511_b(new BlockPos(moprt.hitVec), moprt.sideHit);
			p.swingItem();
		} else KeyBinding.setKeyBindState(Minecraft.getMinecraft().gameSettings.keyBindAttack.getKeyCode(), true);
	}

	@Override
	public int refreshDelay() {
		return Settings.Autoattack.delay;
	}

	@Override
	public void renderText(List<String> str) {
		str.add("Autoattack " + EnumChatFormatting.GREEN + "ON");
		if (Autoattack.delay < 101) str.add(" Speed: " + EnumChatFormatting.GREEN + EnumChatFormatting.ITALIC + Autoattack.delay + " times/s");
		else str.add(" Speed: " + EnumChatFormatting.GREEN + Autoattack.delay + " times/s");
	}
}
