package net.maunium.Maucros.Actions;

import java.util.List;
import java.util.Random;

import net.maunium.Maucros.Config.Settings;

import net.minecraft.client.Minecraft;
import net.minecraft.client.entity.EntityPlayerSP;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.network.play.client.C0EPacketClickWindow;
import net.minecraft.util.EnumChatFormatting;

/**
 * Updated version of AutoSoup.
 * 
 * @author Tulir293
 * @since 1.4.2
 */
public class ActionAutosoup extends DelayAction {
	public ActionAutosoup() {
		super("Autosoup");
	}
	
	private int nextTask = 0, taskModifier = 0, nextSlot = 0, prevSlot = 0, emptySlots = 0;
	private Random mslr = new Random(System.currentTimeMillis());
	
	@Override
	public void executeChecked() {
		EntityPlayerSP p = Minecraft.getMinecraft().thePlayer;
		if (nextTask == 0) {
			prevSlot = p.inventory.currentItem;
			for (int i = 0; i < 9; i++) {
				if (Settings.Autosoup.makeseemlegit && i != 8 && mslr.nextInt(5) == 3) i++;
				if (p.inventory.getStackInSlot(i) == null || p.inventory.getStackInSlot(i).getItem() == null || p.inventory.getStackInSlot(i).stackSize == 0
						|| !p.inventory.getStackInSlot(i).getItem().equals(Items.mushroom_stew)) continue;
				
				if (p.getHealth() < p.getMaxHealth() - 7) {
					p.inventory.currentItem = i;
					nextTask = 1;
				}
				return;
			}
			if (taskModifier == 1) {
				for (int i = 9; i < 36; i++) {
					ItemStack is = p.inventory.getStackInSlot(i);
					if (is != null && is.getItem() != null && is.getItem().equals(Items.mushroom_stew) && is.stackSize != 0) {
						p.inventoryContainer.transferStackInSlot(p, i);
						p.sendQueue.addToSendQueue(new C0EPacketClickWindow(0, i, 0, 1, p.inventory.mainInventory[i], (short) i));
						emptySlots--;
						if (emptySlots == 0) taskModifier = 0;
						else taskModifier = 2;
						return;
					}
				}
				taskModifier = 0;
			} else if (taskModifier == 2) taskModifier++;
			else if (taskModifier == 3) taskModifier++;
			else if (taskModifier == 4) taskModifier++;
			else if (taskModifier == 5) taskModifier = 1;
			
			if (Settings.Autosoup.makeseemlegit) {
				emptySlots = 0;
				for (int i = 0; i < 9; i++) {
					ItemStack is = p.inventory.getStackInSlot(nextSlot);
					if (is == null || is.getItem() == null || is.stackSize == 0) emptySlots++;
				}
				taskModifier++;
			} else {
				for (int i = 9; i < 36; i++) {
					ItemStack is = p.inventory.getStackInSlot(i);
					if (is != null && is.getItem() != null && is.getItem().equals(Items.mushroom_stew) && is.stackSize != 0) {
						p.inventoryContainer.transferStackInSlot(p, i);
						p.sendQueue.addToSendQueue(new C0EPacketClickWindow(0, i, 0, 1, p.inventory.mainInventory[i], (short) i));
						return;
					}
				}
			}
		} else if (nextTask == 1) {
			if (p.inventory.getCurrentItem() != null) Minecraft.getMinecraft().playerController.sendUseItem(p, p.worldObj, p.inventory.getCurrentItem());
			nextTask = 2;
		} else if (nextTask == 2) {
			p.dropOneItem(true);
			p.inventory.currentItem = prevSlot;
			nextTask = 0;
		} else if (nextTask == 10) {
			emptySlots = 0;
			for (int i = 0; i < 9; i++) {
				ItemStack is = p.inventory.getStackInSlot(nextSlot);
				if (is == null || is.getItem() == null || is.stackSize == 0) emptySlots++;
			}
			nextTask = 12;
		} else if (nextTask == 12) {
			for (int i = 9; i < 36; i++) {
				ItemStack is = p.inventory.getStackInSlot(i);
				if (is != null && is.getItem() != null && is.getItem().equals(Items.mushroom_stew) && is.stackSize != 0) {
					p.inventoryContainer.transferStackInSlot(p, i);
					p.sendQueue.addToSendQueue(new C0EPacketClickWindow(0, i, 0, 1, p.inventory.mainInventory[i], (short) i));
					emptySlots--;
					if (emptySlots == 0) nextTask = 0;
					else nextTask = 13;
					break;
				}
			}
		} else if (nextTask == 13) nextTask = 14;
		else if (nextTask == 14) nextTask = 15;
		else if (nextTask == 15) nextTask = 16;
		else if (nextTask == 16) nextTask = 12;
	}
	
	@Override
	public int refreshDelay() {
		return Settings.Autosoup.delay;
	}
	
	@Override
	public void renderText(List<String> str) {
		str.add("Autosoup " + EnumChatFormatting.GREEN + "ON");
		if (Settings.Autosoup.makeseemlegit) str.add(" Legit-looking mode " + EnumChatFormatting.GREEN + "ON");
		if (Settings.Autosoup.delay != 20) str.add(" Tick delay: " + EnumChatFormatting.AQUA + Settings.Autosoup.delay);
		int soup = 0;
		
		for (ItemStack is : Minecraft.getMinecraft().thePlayer.inventory.mainInventory) {
			if (is == null) continue;
			if (is.getItem() == null) continue;
			if (is.getItem().equals(Items.mushroom_stew)) soup++;
		}
		
		if (soup > 18) str.add(EnumChatFormatting.GREEN + " " + soup + " Soup left");
		else if (soup > 8) str.add(EnumChatFormatting.YELLOW + " " + soup + " Soup left");
		else if (soup > 0) str.add(EnumChatFormatting.RED + " " + soup + " Soup left");
		else str.add(EnumChatFormatting.DARK_RED + " " + EnumChatFormatting.BOLD + "No soup left!");
	}
}
