package net.maunium.Maucros.Actions;

import java.util.List;

import net.maunium.Maucros.Config.Settings;

import net.minecraft.block.material.Material;
import net.minecraft.client.Minecraft;
import net.minecraft.client.entity.EntityPlayerSP;
import net.minecraft.client.multiplayer.PlayerControllerMP;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumChatFormatting;
import net.minecraft.util.MovingObjectPosition;

public class ActionAutouse extends DelayAction {
	public ActionAutouse() {
		super("Autouse");
	}
	
	@Override
	public void executeChecked() {
		EntityPlayerSP p = Minecraft.getMinecraft().thePlayer;
		PlayerControllerMP pc = Minecraft.getMinecraft().playerController;
		MovingObjectPosition moprt = p.rayTrace(5.0F, 1);
		if (moprt != null && !p.worldObj.getBlockState(new BlockPos(moprt.hitVec)).getBlock().getMaterial().equals(Material.air)) pc.func_178890_a(p,
				Minecraft.getMinecraft().theWorld, p.inventory.getCurrentItem(), new BlockPos(moprt.hitVec), moprt.sideHit, moprt.hitVec);
		else if (p.inventory.getCurrentItem() != null) pc.sendUseItem(p, p.worldObj, p.inventory.getCurrentItem());
	}
	
	@Override
	public int refreshDelay() {
		return Settings.Delay.autouse;
	}
	
	@Override
	public void renderText(List<String> str) {
		str.add("Autouse " + EnumChatFormatting.GREEN + "ON");
		if (Settings.Delay.autouse < 101) str.add(" Speed: " + EnumChatFormatting.GREEN + EnumChatFormatting.ITALIC + Settings.Delay.autouse + " times/s");
		else str.add(" Speed: " + EnumChatFormatting.GREEN + Settings.Delay.autouse + " times/s");
	}
}
