package net.maunium.Maucros.Actions;

import java.util.HashSet;
import java.util.Set;

import net.maunium.Maucros.Misc.MaucrosLicensor;

/**
 * A class that contains all the Actions, official and unofficial.
 * 
 * @author Tulir293
 * @since 1.4 Alpha 7
 */
public class Actions {
	public final ActionAimbot aimbot = new ActionAimbot();
	public final ActionSpammer spammer = new ActionSpammer();
	public final ActionAttackaura attackaura = new ActionAttackaura();
	public final ActionAutoattack autoattack = new ActionAutoattack();
	public final ActionAutosoup autosoup = new ActionAutosoup();
	public final ActionAutouse autouse = new ActionAutouse();
	public final ActionBlink blink = new ActionBlink();
	public final ActionFly fly = new ActionFly();
	public final ActionNofall nofall = new ActionNofall();
	public final ActionPhase phase = new ActionPhase();
	public final ActionFreecam freecam = new ActionFreecam();
	private Set<Action> unofficial = new HashSet<Action>();
	
	private static Actions instance;
	
	public static Actions create() {
		if (!MaucrosLicensor.check()) throw new RuntimeException("Maucros not licenced");
		instance = new Actions();
		return instance;
	}
	
	public void registerAction(Action act){
		unofficial.add(act);
	}
	
	public void unregisterAction(Action act){
		unofficial.remove(act);
	}
	
	public Set<Action> getActions(){
		return unofficial;
	}
	
	private Actions() {}
	
	public static Actions getInstance() {
		return instance;
	}
	
	public static Action getAction(String s) {
		return getInstance().getByName(s);
	}
	
	public Action getByName(String s) {
		if (s.equalsIgnoreCase(aimbot.getName())) return aimbot;
		else if (s.equalsIgnoreCase(spammer.getName())) return spammer;
		else if (s.equalsIgnoreCase(attackaura.getName())) return attackaura;
		else if (s.equalsIgnoreCase(autoattack.getName())) return autoattack;
		else if (s.equalsIgnoreCase(autosoup.getName())) return autosoup;
		else if (s.equalsIgnoreCase(autouse.getName())) return autouse;
		else if (s.equalsIgnoreCase(blink.getName())) return blink;
		else if (s.equalsIgnoreCase(fly.getName())) return fly;
		else if (s.equalsIgnoreCase(nofall.getName())) return nofall;
		else if (s.equalsIgnoreCase(phase.getName())) return phase;
		else for (Action a : unofficial)
			if (a.getName().equalsIgnoreCase(s)) return a;
		return null;
	}
}
