package net.maunium.Maucros.KeyMaucros.Commands;

import net.maunium.Maucros.Maucros;

public class CommandDelay implements MaucroCommand {
	
	@Override
	public String getOwner() {
		return "Maucros";
	}
	
	@Override
	public String getName() {
		return "Delay";
	}
	
	@Override
	@SuppressWarnings("deprecation")
	public void execute(String label, String[] args) {
		if (args.length > 0) try {
			Thread.sleep(Integer.parseInt(args[0]));
		} catch (NumberFormatException e) {
			Maucros.printChatError("The MaucroCommand Delay takes one integer.");
		} catch (InterruptedException e) { }
		else Maucros.printChatError("The MaucroCommand Delay takes one integer.");
	}
	
}
