package net.maunium.Maucros.KeyMaucros.Commands;

import net.maunium.Maucros.Maucros;

import net.minecraft.client.Minecraft;

public class CommandLook implements MaucroCommand {
	
	@Override
	public String getOwner() {
		return "Maucros";
	}
	
	@Override
	public String getName() {
		return "Look";
	}
	
	@Override
	@SuppressWarnings("deprecation")
	public void execute(String label, String[] args) {
		if (args.length > 1) {
			int yaw, pitch;
			try {
				yaw = Integer.parseInt(args[0]);
				pitch = Integer.parseInt(args[1]);
			} catch (NumberFormatException e) {
				Maucros.printChatError("The MaucroCommand Look takes two integers.");
				return;
			}
			Minecraft.getMinecraft().thePlayer.rotationYaw = yaw;
			Minecraft.getMinecraft().thePlayer.rotationPitch = pitch;
		} else Maucros.printChatError("The MaucroCommand Look takes two integers.");
	}
	
}
