package net.maunium.Maucros.Listeners;

import java.util.Arrays;
import java.util.List;

import org.lwjgl.input.Mouse;

import net.maunium.Maucros.Maucros;
import net.maunium.Maucros.Config.ServerInfo;
import net.maunium.Maucros.Config.Settings;
import net.maunium.Maucros.Gui.GuiSpawnItem;

import net.minecraft.client.Minecraft;
import net.minecraft.potion.Potion;
import net.minecraft.potion.PotionEffect;
import net.minecraft.util.EnumChatFormatting;
import net.minecraft.util.StatCollector;

import net.minecraftforge.client.event.RenderGameOverlayEvent;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;

public class OverlayRenderListener {
	private Maucros host;
	
	public OverlayRenderListener(Maucros host) {
		this.host = host;
	}
	
	private List<Integer> negative = Arrays.asList(2, 4, 7, 9, 15, 17, 18, 19, 20);
	private List<Integer> positive = Arrays.asList(1, 3, 5, 6, 8, 10, 11, 12, 13, 14, 16, 21, 22, 23);
	
	@SubscribeEvent
	public void renderOverlay(RenderGameOverlayEvent.Text evt) {
		if (Settings.disabled && !Settings.Enabled.render) return;
		if (Minecraft.getMinecraft().gameSettings.showDebugInfo) {
			if (ServerInfo.hasCurrent()) evt.right.add("Server: " + ServerInfo.getCurrent());
			if (Minecraft.getMinecraft().currentScreen != null) evt.right.add("Mouse: " + Mouse.getX() + ", " + Mouse.getX());
			return;
		} else {
			for (Object o : Minecraft.getMinecraft().thePlayer.getActivePotionEffects()) {
				if (o instanceof PotionEffect) {
					PotionEffect pe = (PotionEffect) o;
					String name = StatCollector.translateToLocal(pe.getEffectName()) + " " + GuiSpawnItem.toRoman(pe.getAmplifier() + 1)
							+ EnumChatFormatting.WHITE + ": ";
					if (negative.contains(pe.getPotionID())) name = EnumChatFormatting.RED + name;
					else if (positive.contains(pe.getPotionID())) name = EnumChatFormatting.GREEN + name;
					if (pe.getIsAmbient()) evt.right.add(name + EnumChatFormatting.GREEN + "Ambient");
					else if (pe.getIsPotionDurationMax()) evt.right.add(name + EnumChatFormatting.GREEN + "Infinite");
					else {
						String time;
						if (pe.getDuration() < 200) time = EnumChatFormatting.RED + Potion.getDurationString(pe);
						else if (pe.getDuration() < 1200) time = EnumChatFormatting.YELLOW + Potion.getDurationString(pe);
						else time = EnumChatFormatting.GREEN + Potion.getDurationString(pe);
						evt.right.add(name + time);
					}
				}
			}
		}
		
		if (Settings.Enabled.aimbot) host.getActions().aimbot.renderText(evt.left);
		if (Settings.Enabled.attackaura) host.getActions().attackaura.renderText(evt.left);
		if (Settings.Enabled.autoattack) host.getActions().autoattack.renderText(evt.left);
		if (Settings.Enabled.autosoup) host.getActions().autosoup.renderText(evt.left);
		if (Settings.Enabled.autouse) host.getActions().autouse.renderText(evt.left);
		if (Settings.Enabled.blink) host.getActions().blink.renderText(evt.left);
		if (Settings.Enabled.fly != 0) host.getActions().fly.renderText(evt.left);
		if (Settings.Enabled.freecam) host.getActions().freecam.renderText(evt.left);
		if (Settings.Enabled.fullbright) evt.left.add("Fullbright " + EnumChatFormatting.GREEN + "ON");
		if (Settings.Enabled.nofall) host.getActions().nofall.renderText(evt.left);
		if (host.getActions().phase.isPhasing()) phase(evt.left);
		if (Settings.Enabled.playerESP) evt.left.add("Player ESP " + EnumChatFormatting.GREEN + "ON");
		if (Settings.Enabled.tracer) evt.left.add("Player Tracer " + EnumChatFormatting.GREEN + "ON");
		if (Settings.Enabled.trajectories) evt.left.add("Trajectories " + EnumChatFormatting.GREEN + "ON");
		if (Settings.Enabled.spammer) host.getActions().spammer.renderText(evt.left);
		if (Settings.Enabled.xray) evt.left.add("X-Ray " + EnumChatFormatting.GREEN + "ON");
	}
	
	private void phase(List<String> str) {
		str.add("Automated Phase " + EnumChatFormatting.GREEN + "ON");
		if (Settings.Phase.autoforward) str.add(" Auto-forward: " + EnumChatFormatting.GREEN + "ON");
		else str.add(" Auto-forward: " + EnumChatFormatting.RED + "OFF");
	}
}
