package net.maunium.Maucros.Listeners;

import java.nio.charset.StandardCharsets;

import net.maunium.Maucros.Maucros;
import net.maunium.Maucros.Config.Settings;

import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.common.network.FMLNetworkEvent.ClientCustomPacketEvent;

public class PacketListener {
	
	@SubscribeEvent
	public void onPacketReceived(ClientCustomPacketEvent evt) {
		if(Settings.disabled) return;
		String s = evt.packet.payload().toString(StandardCharsets.UTF_8);
		if (s.equals("accepted")) Maucros.printChatLocalized("message.server.accepted");
		else {
			Maucros.printChatErrorLocalized("message.server.denied", s);
			Settings.disabled = true;
		}
	}
}
