package net.maunium.Maucros.Actions;

import java.util.ArrayList;
import java.util.List;

import net.maunium.Maucros.Config.Settings;

import net.minecraft.client.Minecraft;
import net.minecraft.client.network.NetHandlerPlayClient;
import net.minecraft.network.Packet;
import net.minecraft.util.EnumChatFormatting;

public class ActionBlink extends Action {
	public ActionBlink() {
		super("Blink");
	}
	
	@Override
	public void execute() {
		throw new UnsupportedOperationException("The method execute is not supported for the action Blink");
	}
	
	private static List<Packet> packets = new ArrayList<Packet>();
	private static long blinkStart = 0;
	
	public static void startBlinking() {
		blinkStart = Minecraft.getSystemTime();
		Settings.Enabled.blink = true;
	}
	
	public static void blink(Packet p) {
		if (Settings.Blink.automated && Settings.Blink.safetyLevel > 0) {
			if (blinkStart + Settings.Blink.safetyLevel * 1000 < Minecraft.getSystemTime()) {
				releaseBlink();
				startBlinking();
			}
			packets.add(p);
		} else if (Settings.Blink.safetyLevel > 0) {
			if (blinkStart + Settings.Blink.safetyLevel * 1000 < Minecraft.getSystemTime()) releaseBlink();
			else packets.add(p);
		} else packets.add(p);
	}
	
	public static void releaseBlink() {
		Settings.Enabled.blink = false;
		NetHandlerPlayClient nhpc = Minecraft.getMinecraft().thePlayer.sendQueue;
		for (Packet p : packets)
			nhpc.addToSendQueue(p);
		packets.clear();
	}

	@Override
	public void renderText(List<String> str) {
		if (Settings.Blink.automated && Settings.Blink.safetyLevel != 0) {
			str.add("Blink " + EnumChatFormatting.GREEN + "Automated");
			if (Settings.Blink.safetyLevel < 5) str.add(" Release delay: " + EnumChatFormatting.GREEN + Settings.Blink.safetyLevel + " seconds");
			else str.add(" Release delay: " + EnumChatFormatting.RED + Settings.Blink.safetyLevel + " seconds");
		} else {
			str.add("Blink " + EnumChatFormatting.RED + "Manual");
			if (Settings.Blink.safetyLevel > 4) str.add(" Release delay: " + EnumChatFormatting.RED + Settings.Blink.safetyLevel + " seconds");
			else if (Settings.Blink.safetyLevel > 0) str.add(" Release delay: " + EnumChatFormatting.GREEN + Settings.Blink.safetyLevel + " seconds");
			else str.add(" Safety: " + EnumChatFormatting.RED + "Disabled");
		}
	}
}
