package net.maunium.Maucros.Actions;

import java.util.List;

import org.lwjgl.input.Keyboard;

import net.maunium.Maucros.Config.Settings;

import net.minecraft.client.Minecraft;
import net.minecraft.client.settings.GameSettings;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.EnumChatFormatting;

public class ActionFly extends Action {
	public ActionFly() {
		super("Fly");
	}
	
	@Override
	public void execute() {
		exec();
	}
	
	public static void exec() {
		if (Settings.disabled) return;
		if (Settings.Enabled.fly == 0) return;
		GameSettings gs = Minecraft.getMinecraft().gameSettings;
		EntityPlayer p = Minecraft.getMinecraft().thePlayer;
		
		if (!Minecraft.getMinecraft().inGameHasFocus) {
			if (Settings.Enabled.fly == 1) {
				p.motionX = 0;
				p.motionY = 0;
				p.motionZ = 0;
			}
			return;
		}
		
		double extra = 0;
		if (Settings.Enabled.fly == 1) p.setSprinting(false);
		else extra = (p.isSprinting() ? Settings.Fly.getRealSpeed() / 5 : 0) - (p.isSneaking() ? Settings.Fly.getRealSpeed() / 5 : 0);
		
		double mX = p.motionX;
		double mY = p.motionY;
		double mZ = p.motionZ;
		float yaw = p.rotationYaw % 360;
		
		if (Keyboard.isKeyDown(gs.keyBindForward.getKeyCode())) {
			if (Keyboard.isKeyDown(gs.keyBindRight.getKeyCode())) {
				yaw += 135;
				if (yaw > 360) yaw -= 360;
			} else if (Keyboard.isKeyDown(gs.keyBindLeft.getKeyCode())) {
				yaw += 45;
				if (yaw > 360) yaw -= 360;
			} else {
				yaw += 90;
				if (yaw > 360) yaw -= 360;
			}
			mX = Math.cos(Math.toRadians(yaw)) * (Settings.Fly.getRealSpeed() + extra);
			mZ = Math.sin(Math.toRadians(yaw)) * (Settings.Fly.getRealSpeed() + extra);
		} else if (Keyboard.isKeyDown(gs.keyBindBack.getKeyCode())) {
			if (Keyboard.isKeyDown(gs.keyBindRight.getKeyCode())) {
				yaw -= 135;
				if (yaw > 360) yaw += 360;
			} else if (Keyboard.isKeyDown(gs.keyBindLeft.getKeyCode())) {
				yaw -= 45;
				if (yaw > 360) yaw += 360;
			} else {
				yaw -= 90;
				if (yaw > 360) yaw += 360;
			}
			mX = Math.cos(Math.toRadians(yaw)) * (Settings.Fly.getRealSpeed() + extra);
			mZ = Math.sin(Math.toRadians(yaw)) * (Settings.Fly.getRealSpeed() + extra);
		} else if (Keyboard.isKeyDown(gs.keyBindRight.getKeyCode())) {
			mX = -Math.cos(Math.toRadians(yaw)) * (Settings.Fly.getRealSpeed() + extra);
			mZ = -Math.sin(Math.toRadians(yaw)) * (Settings.Fly.getRealSpeed() + extra);
		} else if (Keyboard.isKeyDown(gs.keyBindLeft.getKeyCode())) {
			mX = Math.cos(Math.toRadians(yaw)) * (Settings.Fly.getRealSpeed() + extra);
			mZ = Math.sin(Math.toRadians(yaw)) * (Settings.Fly.getRealSpeed() + extra);
		} else if (Settings.Enabled.fly == 1) {
			mX = 0;
			mZ = 0;
		}
		if (Settings.Enabled.fly == 1) {
			if (Keyboard.isKeyDown(gs.keyBindJump.getKeyCode())) {
				if (Keyboard.isKeyDown(gs.keyBindSneak.getKeyCode())) mY = 0;
				else mY = Settings.Fly.getRealSpeed();
			} else if (Keyboard.isKeyDown(gs.keyBindSneak.getKeyCode())) mY = -Settings.Fly.getRealSpeed();
			else mY = 0;
		} else if (Keyboard.isKeyDown(gs.keyBindJump.getKeyCode())) if (Settings.Fly.jumpHeight == 0) mY = Settings.Fly.getRealSpeed() * 2;
		else mY = Settings.Fly.jumpHeight;
		
		p.setVelocity(mX, mY, mZ);
	}
	
	@Override
	public void renderText(List<String> str) {
		str.add("Alt. Movement " + EnumChatFormatting.GREEN + "ON");
		str.add(" Mode " + EnumChatFormatting.GREEN + (Settings.Enabled.fly == 1 ? "Fly" : "Walk"));
		if (Settings.Fly.getSpeed() > Settings.Fly.getMaxSpeed() / 2) str.add(" Speed " + EnumChatFormatting.RED + "" + EnumChatFormatting.ITALIC
				+ Settings.Fly.getSpeed());
		else if (Settings.Fly.getSpeed() > Settings.Fly.getMaxSpeed() / 4) str.add(" Speed " + EnumChatFormatting.GREEN + "" + EnumChatFormatting.ITALIC
				+ Settings.Fly.getSpeed());
		else str.add(" Speed " + EnumChatFormatting.GREEN + "" + Settings.Fly.getSpeed());
	}
}
