package net.maunium.Maucros.Actions;

import org.lwjgl.input.Keyboard;

import net.maunium.Maucros.Config.Settings;
import net.maunium.Maucros.Misc.EntityFreecam;

import net.minecraft.client.Minecraft;
import net.minecraft.client.entity.EntityPlayerSP;

/**
 * 
 * @author Tulir293
 * @since 1.4 Beta 2
 */
public class ActionFreecam extends Action {
	public ActionFreecam() {
		super("Freecam");
	}
	
	private EntityFreecam f = null;
	private Minecraft mc = Minecraft.getMinecraft();
//	private MovementInput mi = new MovementInput();
	
	public EntityFreecam getFreecamEntity() {
		return f;
	}
	
	public void enable() {
		Settings.Enabled.freecam = true;
		if (mc.thePlayer != null) {
			f = new EntityFreecam(mc.thePlayer);
			f.setPosition(mc.thePlayer.posX, mc.thePlayer.posY, mc.thePlayer.posZ);
			f.boundingBox = mc.thePlayer.boundingBox.offset(0, 0, 0);
			f.rotationYaw = mc.thePlayer.rotationYaw;
			f.rotationPitch = mc.thePlayer.rotationPitch;
			f.rotationYawHead = mc.thePlayer.rotationYawHead;
			
			mc.thePlayer.worldObj.spawnEntityInWorld(f);
		}
		mc.renderViewEntity = f;
	}
	
	public void disable() {
		Settings.Enabled.freecam = false;
		if (f != null && mc.thePlayer != null) {
			f.setHealth(0);
			f.setDead();
			mc.thePlayer.worldObj.removeEntity(f);
			f = null;
		}
		mc.renderViewEntity = mc.thePlayer;
	}
	
	@Override
	public void execute() {
		EntityPlayerSP p = mc.thePlayer;
//		f.yOffset = p.yOffset;
//		f.ySize = p.ySize;
		
		if (!Minecraft.getMinecraft().inGameHasFocus) {
			f.motionX = 0;
			f.motionY = 0;
			f.motionZ = 0;
			return;
		}
		
//		f.ySize = 0.0F;
		f.setSprinting(false);
		
		double mX = f.motionX;
		double mY = f.motionY;
		double mZ = f.motionZ;
		float yaw = f.rotationYaw % 360;
		
		if (Keyboard.isKeyDown(Settings.Freecam.Move.forward)) {
			if (Keyboard.isKeyDown(Settings.Freecam.Move.right)) {
				yaw += 135;
				if (yaw > 360) yaw -= 360;
			} else if (Keyboard.isKeyDown(Settings.Freecam.Move.left)) {
				yaw += 45;
				if (yaw > 360) yaw -= 360;
			} else {
				yaw += 90;
				if (yaw > 360) yaw -= 360;
			}
			mX = Math.cos(Math.toRadians(yaw)) * (Settings.Fly.getRealSpeed());
			mZ = Math.sin(Math.toRadians(yaw)) * (Settings.Fly.getRealSpeed());
//			mi.moveForward = (float) (Settings.Fly.getRealSpeed() / 10);
		} else if (Keyboard.isKeyDown(Settings.Freecam.Move.back)) {
			if (Keyboard.isKeyDown(Settings.Freecam.Move.right)) {
				yaw -= 135;
				if (yaw > 360) yaw += 360;
			} else if (Keyboard.isKeyDown(Settings.Freecam.Move.left)) {
				yaw -= 45;
				if (yaw > 360) yaw += 360;
			} else {
				yaw -= 90;
				if (yaw > 360) yaw += 360;
			}
			mX = Math.cos(Math.toRadians(yaw)) * (Settings.Fly.getRealSpeed());
			mZ = Math.sin(Math.toRadians(yaw)) * (Settings.Fly.getRealSpeed());
//			mi.moveForward = (float) -(Settings.Fly.getRealSpeed() / 10);
		} else if (Keyboard.isKeyDown(Settings.Freecam.Move.right)) {
			mX = -Math.cos(Math.toRadians(yaw)) * (Settings.Fly.getRealSpeed());
			mZ = -Math.sin(Math.toRadians(yaw)) * (Settings.Fly.getRealSpeed());
//			mi.moveStrafe = (float) -(Settings.Fly.getRealSpeed() / 10);
		} else if (Keyboard.isKeyDown(Settings.Freecam.Move.left)) {
			mX = Math.cos(Math.toRadians(yaw)) * (Settings.Fly.getRealSpeed());
			mZ = Math.sin(Math.toRadians(yaw)) * (Settings.Fly.getRealSpeed());
//			mi.moveStrafe = (float) (Settings.Fly.getRealSpeed() / 10);
		} else {
			mX = 0;
			mZ = 0;
		}
		
		if (Keyboard.isKeyDown(Settings.Freecam.Move.up)) {
			if (Keyboard.isKeyDown(Settings.Freecam.Move.down)) mY = 0;
			else mY = Settings.Fly.getRealSpeed();
		} else if (Keyboard.isKeyDown(Settings.Freecam.Move.down)) mY = -Settings.Fly.getRealSpeed();
		else mY = 0;
		
		f.posX = f.posX + (mX / 3);
		f.posY = f.posY + (mY / 3);
		f.posZ = f.posZ + (mZ / 3);
//		mi.jump = false;
//		mi.sneak = false;
//		f.setMovementInput(mi);
//		f.motionX = mX;
//		f.motionY = mY;
//		f.motionZ = mZ;
		
		float oy = f.rotationYaw;
		float op = f.rotationPitch;
		float mod = 1.2F;
		
		if (Settings.Freecam.View.useMouse) {
			f.rotationPitch = p.rotationPitch;
			f.rotationYaw = p.rotationYaw;
		} else {
			if (Keyboard.isKeyDown(Settings.Freecam.View.down)) f.rotationPitch = op + mod;
			if (Keyboard.isKeyDown(Settings.Freecam.View.left)) f.rotationYaw = oy - mod;
			if (Keyboard.isKeyDown(Settings.Freecam.View.right)) f.rotationYaw = oy + mod;
			if (Keyboard.isKeyDown(Settings.Freecam.View.up)) f.rotationPitch = op - mod;
			if (Keyboard.isKeyDown(Settings.Freecam.View.downleft)) {
				f.rotationYaw -= mod;
				f.rotationPitch += mod;
			}
			if (Keyboard.isKeyDown(Settings.Freecam.View.downright)) {
				f.rotationYaw = oy + mod;
				f.rotationPitch = op + mod;
			}
			
			if (Keyboard.isKeyDown(Settings.Freecam.View.upleft)) {
				f.rotationYaw = oy - mod;
				f.rotationPitch = op - mod;
			}
			if (Keyboard.isKeyDown(Settings.Freecam.View.upright)) {
				f.rotationYaw = oy + mod;
				f.rotationPitch = op - mod;
			}
			if (Keyboard.isKeyDown(Settings.Freecam.View.reset)) {
				f.rotationYaw = 0;
				f.rotationPitch = 0;
			}
		}

		if (mc.renderViewEntity != f) mc.renderViewEntity = f;
	}
	
	public void actualEntityMove(){
		
	}
}
