package net.maunium.Maucros.Gui.Config;

import java.io.IOException;

import com.mcf.davidee.guilib.basic.Label;
import com.mcf.davidee.guilib.core.Button;
import com.mcf.davidee.guilib.core.Container;
import com.mcf.davidee.guilib.vanilla.ButtonVanilla;
import com.mcf.davidee.guilib.vanilla.TextFieldVanilla;

import net.maunium.Maucros.Maucros;
import net.maunium.Maucros.Config.Configurations;
import net.maunium.Maucros.Config.Settings;
import net.maunium.Maucros.Gui.MauScreen;
import net.maunium.Maucros.Gui.MaucrosGuiHandler;
import net.maunium.Maucros.Gui.KeyMaucros.GuiKeyMaucros;
import net.maunium.Maucros.Gui.KeyMaucros.GuiLuaThreads;
import net.maunium.Maucros.Gui.Widgets.MintSlider;
import net.maunium.Maucros.Gui.Widgets.StateButton;
import net.maunium.Maucros.Logging.MaucrosLogger;
import net.maunium.Maucros.Misc.I18n;

import net.minecraft.client.Minecraft;

public class GuiConfig extends MauScreen {
	private Maucros host;
	
	private Container c;
	private Label title, langTitle;
	private MintSlider ause_delay, amov_speed, spammer_delay, asoup_delay, aattack_delay, jump_height, blink_safety, aimbot_delay, aaura_delay, flushLineCount;
	private StateButton asoup_makeseemlegit, phase_automated, phase_autoforward, logType, debugType, blink_automated, autoSave;
	private ButtonVanilla fAndA, keyMaucros, backToGame, mauchat, usernameChanger, nextPage, prevPage, xRay, enableds, langSave, flushLog, loadConfig,
			saveConfig, freecamKeys, luaThreads, itemSpawner, screenshot, encryption;
	private TextFieldVanilla language;
	private static int page = 0;
	
	public GuiConfig(Maucros host) {
		super(null);
		this.host = host;
	}
	
	@Override
	public void onInit() {
		Maucros.getLogger().debug("Creating mint sliders", this);
		ause_delay = new MintSlider(I18n.format("conf.autouse.delay"), Settings.Delay.autouse, 1, 500);
		amov_speed = new MintSlider(I18n.format("conf.amov.speed"), Settings.Fly.getSpeed(), Settings.Fly.getMinSpeed(), Settings.Fly.getMaxSpeed());
		jump_height = new MintSlider(jumpHeightFormat, (int) (Settings.Fly.jumpHeight * 10), 0, 100);
		spammer_delay = new MintSlider(I18n.format("conf.spammer.delay"), Settings.Delay.spammer, 1, 1000);
		aattack_delay = new MintSlider(I18n.format("conf.autoattack.delay"), Settings.Autoattack.delay, 1, 500);
		aaura_delay = new MintSlider(I18n.format("conf.attackaura.delay"), Settings.Delay.attackaura, 1, 500);
		aimbot_delay = new MintSlider(I18n.format("conf.aimbot.delay"), Settings.Delay.aimbot, 1, 500);
		asoup_delay = new MintSlider(I18n.format("conf.autosoup.delay"), Settings.Autosoup.delay, 10, 100);
		blink_safety = new MintSlider(blinkFormat, Settings.Blink.safetyLevel, 0, 10);
		flushLineCount = new MintSlider(flcFormat, MaucrosLogger.flushLineCount, 0, 100);
		
		
		Maucros.getLogger().debug("Creating State Buttons", this);
		blink_automated = new StateButton(150, 20, I18n.format("conf.blink.automated"), this, Settings.Blink.automated ? 1 : 0);
		asoup_makeseemlegit = new StateButton(150, 20, I18n.format("conf.autosoup.legitmode"), this, Settings.Autosoup.makeseemlegit ? 1 : 0);
		phase_automated = new StateButton(150, 20, I18n.format("conf.phase.automated"), this, Settings.Phase.automated ? 1 : 0);
		phase_autoforward = new StateButton(150, 20, I18n.format("conf.phase.autoforward"), this, Settings.Phase.autoforward ? 1 : 0);
		autoSave = new StateButton(150, 20, I18n.format("conf.autosave"), this, Settings.Enabled.autosave ? 1 : 0);
		debugType = new StateButton(150, 20, this, Maucros.getLogger().getDebugType(), new StateButton.GenericFormat(I18n.format("conf.log.debug"),
				I18n.format("conf.log.debug.disabled"), I18n.format("conf.log.debug.basic"), I18n.format("conf.log.debug.full")));
		logType = new StateButton(150, 20, this, Maucros.getLogger().getLogType(), new StateButton.GenericFormat(I18n.format("conf.log"),
				I18n.format("conf.log.file"), I18n.format("conf.log.console"), I18n.format("conf.log.chat")));
		
		Maucros.getLogger().debug("Creating Click Buttons", this);
		fAndA = new ButtonVanilla(150, 20, I18n.format("conf.fanda.enter"), this);
		keyMaucros = new ButtonVanilla(150, 20, I18n.format("conf.keymaucros.enter"), this);
		enableds = new ButtonVanilla(150, 20, I18n.format("conf.enabled.enter"), this);
		backToGame = new ButtonVanilla(150, 20, I18n.format("conf.backtogame"), this);
		usernameChanger = new ButtonVanilla(150, 20, I18n.format("conf.username.title"), this);
		xRay = new ButtonVanilla(150, 20, I18n.format("conf.xray.enter"), this);
		langSave = new ButtonVanilla(150, 20, I18n.format("conf.language.save"), this);
		flushLog = new ButtonVanilla(150, 20, I18n.format("conf.log.flush"), this);
		loadConfig = new ButtonVanilla(150, 20, I18n.format("conf.load"), this);
		saveConfig = new ButtonVanilla(150, 20, I18n.format("conf.save"), this);
		freecamKeys = new ButtonVanilla(150, 20, I18n.format("conf.freecam.enter"), this);
		itemSpawner = new ButtonVanilla(150, 20, I18n.format("conf.spawnitem.enter"), this);
		luaThreads = new ButtonVanilla(150, 20, I18n.format("conf.lua.threads.enter"), this);
		screenshot = new ButtonVanilla(150, 20, I18n.format("conf.screenshot.enter"), this);
		encryption = new ButtonVanilla(150, 20, I18n.format("conf.encryption.enter"), this);
		if(!Settings.Enabled.lua) luaThreads.setEnabled(false);
		
		language = new TextFieldVanilla(88, 20, new TextFieldVanilla.VanillaFilter());
		language.setText(Settings.language != null ? Settings.language : Minecraft.getMinecraft().gameSettings.language);
		langTitle = new Label(I18n.format("conf.language"), false);
		
		nextPage = new ButtonVanilla(150, 20, I18n.format("conf.page.next"), this);
		prevPage = new ButtonVanilla(150, 20, I18n.format("conf.page.prev"), this);
		mauchat = new ButtonVanilla(150, 20, I18n.format("conf.mauchat.enter"), this);
		mauchat.setEnabled(false);
		
		title = new Label("");
		
		Maucros.getLogger().trace("Creating container", this);
		c = new Container();
		Maucros.getLogger().trace("Adding container", this);
		containers.add(c);
	}
	
	@Override
	public void onReval() {
		title.setPosition(width / 2, 15);
		title.setText(I18n.format("conf.title", Maucros.version, page + 1));
		int xp1 = width / 2 - 150 - 12;
		int xp2 = width / 2 + 12;
		int mod = 25;
		
		c.getWidgets().clear();
		c.addWidgets(title);
		if (page == 0) {
			Maucros.getLogger().trace("Setting positions for objects on page 1", this);
			fAndA.setPosition(xp1, mod(2));
			ause_delay.setPosition(xp2, mod(2));
			keyMaucros.setPosition(xp1, mod(3));
			spammer_delay.setPosition(xp2, mod(3));
			enableds.setPosition(xp1, mod(4));
			amov_speed.setPosition(xp2, mod(4));
			asoup_makeseemlegit.setPosition(xp1, mod(5));
			jump_height.setPosition(xp2, mod(5));
			aattack_delay.setPosition(xp1, mod(6));
			asoup_delay.setPosition(xp2, mod(6));
			aimbot_delay.setPosition(xp1, mod(7));
			aaura_delay.setPosition(xp2, mod(7));
			backToGame.setPosition(xp1, mod(8));
			nextPage.setPosition(xp2, mod(8));
			
			Maucros.getLogger().trace("Adding widgets for page 1", this);
			c.addWidgets(fAndA, ause_delay, keyMaucros, spammer_delay, enableds, amov_speed, asoup_makeseemlegit, jump_height, asoup_delay, aattack_delay,
					aimbot_delay, aaura_delay, nextPage, backToGame);
		} else if (page == 1) {
			Maucros.getLogger().trace("Setting positions for objects on page 2", this);
			blink_automated.setPosition(xp1, mod(2));
			phase_automated.setPosition(xp2, mod(2));
			blink_safety.setPosition(xp1, mod(3));
			phase_autoforward.setPosition(xp2, mod(3));
			flushLineCount.setPosition(xp1, mod(4));
			logType.setPosition(xp2, mod(4));
			xRay.setPosition(xp1, mod(5));
			debugType.setPosition(xp2, mod(5));
			usernameChanger.setPosition(xp1, mod(6));
			mauchat.setPosition(xp2, mod(6));
			freecamKeys.setPosition(xp1, mod(7));
			luaThreads.setPosition(xp2, mod(7));
			prevPage.setPosition(xp1, mod(8));
			nextPage.setPosition(xp2, mod(8));
			
			Maucros.getLogger().trace("Adding widgets for page 2", this);
			c.addWidgets(blink_automated, blink_safety, phase_automated, phase_autoforward, xRay, flushLineCount, logType, debugType, usernameChanger, mauchat,
					freecamKeys, luaThreads, prevPage, nextPage);
		} else if (page == 2) {
			Maucros.getLogger().trace("Setting positions for objects on page 3", this);
			flushLog.setPosition(xp1, mod(2));
			autoSave.setPosition(xp2, mod(2));
			loadConfig.setPosition(xp1, mod(3));
			saveConfig.setPosition(xp2, mod(3));
			langTitle.setPosition(xp1 + 2, mod(4) + 2);
			language.setPosition(xp1 + 60, mod(4));
			langSave.setPosition(xp2, mod(4));
			itemSpawner.setPosition(xp1, mod(5));
			screenshot.setPosition(xp2, mod(5));
			encryption.setPosition(xp1, mod(6));
			
			prevPage.setPosition(xp1, mod(8));
			backToGame.setPosition(xp2, mod(8));
			
			Maucros.getLogger().trace("Adding widgets for page 3", this);
			c.addWidgets(flushLog, autoSave, loadConfig, saveConfig, language, langTitle, langSave, itemSpawner, screenshot, encryption, prevPage, backToGame);
		}
		
		Maucros.getLogger().trace("Revalidating container", this);
		c.revalidate(0, 0, width, height);
	}
	
	private int mod(int x) {
		return x * 25;
	}
	
	public void setPage(int page) {
		GuiConfig.page = page;
		revalidateGui();
	}
	
	@Override
	public void save() {
		Settings.Delay.autouse = ause_delay.getIntValue();
		Settings.Delay.spammer = spammer_delay.getIntValue();
		Settings.Delay.aimbot = aimbot_delay.getIntValue();
		Settings.Delay.attackaura = aaura_delay.getIntValue();
		
		Settings.Autoattack.delay = aattack_delay.getIntValue();
		
		Settings.Fly.setSpeed(amov_speed.getIntValue());
		Settings.Fly.jumpHeight = jump_height.getIntValue() / 10.0;
		
		Settings.Autosoup.delay = asoup_delay.getIntValue();
		Settings.Autosoup.makeseemlegit = asoup_makeseemlegit.getState() == 1;
		
		Settings.Blink.safetyLevel = blink_safety.getIntValue();
		Settings.Blink.automated = blink_automated.getState() == 1;
		
		Settings.Phase.automated = phase_automated.getState() == 1;
		Settings.Phase.autoforward = phase_autoforward.getState() == 1;
				
		Maucros.getLogger().setLogType(logType.getState());
		Maucros.getLogger().setDebugType(debugType.getState());
		try {
			Maucros.getLogger().flush();
		} catch (IOException e) {
			Maucros.getLogger().catching(e);
		}
		MaucrosLogger.flushLineCount = flushLineCount.getIntValue();
		Maucros.getLogger().trace("Saving configuration to disk", this);
		try {
			Configurations.Generic.save();
		} catch (IOException e) {
			Maucros.getLogger().warning("Failed to save generic configuration!");
			Maucros.getLogger().catching(e);
		}
	}
	
	@Override
	public void onKeyTyped(char c, int kc) {
		if (kc == host.getKeybindings().getPublicKeyCode(host.getKeybindings().CONFIG)) close();
		else super.onKeyTyped(c, kc);
	}
	
	@Override
	public void onButtonClicked(Button button) {
		if (button.equals(keyMaucros)) Minecraft.getMinecraft().displayGuiScreen(new GuiKeyMaucros(this));
		else if (button.equals(freecamKeys)) Minecraft.getMinecraft().displayGuiScreen(new GuiFreecamKeys(this));
		else if (button.equals(fAndA)) Minecraft.getMinecraft().displayGuiScreen(new GuiFriendsAndAttacking(this));
		else if (button.equals(luaThreads) && Settings.Enabled.lua) Minecraft.getMinecraft().displayGuiScreen(new GuiLuaThreads(this));
		else if (button.equals(enableds)) Minecraft.getMinecraft().displayGuiScreen(new GuiEnabled(this));
		else if (button.equals(xRay)) MaucrosGuiHandler.openGui(5);
		else if (button.equals(usernameChanger)) MaucrosGuiHandler.openGui(2);
		else if (button.equals(itemSpawner)) MaucrosGuiHandler.openGui(3);
		else if (button.equals(screenshot)) Minecraft.getMinecraft().displayGuiScreen(new GuiScreenshot(this));
		else if (button.equals(encryption)) Minecraft.getMinecraft().displayGuiScreen(new GuiEncryption(this));
		else if (button.equals(backToGame)) close();
		else if (button.equals(loadConfig)) host.loadConfig();
		else if (button.equals(saveConfig)) host.saveConfig();
		else if (button.equals(flushLog)) {
			try {
				Maucros.getLogger().flush();
			} catch (IOException e) {
				Maucros.getLogger().catching(e);
			}
			try {
				Maucros.getChatLogger().flush();
			} catch (IOException e) {
				Maucros.getLogger().catching(e);
			}
		} else if (button.equals(nextPage)) {
			if (page == 0) setPage(1);
			else if (page == 1) setPage(2);
			else setPage(0);
		} else if (button.equals(prevPage)) {
			if (page == 1) setPage(0);
			else if (page == 2) setPage(1);
			else setPage(0);
		} else if (button.equals(langSave)) {
			String mcl = Minecraft.getMinecraft().gameSettings.language;
			if (!language.getText().equals(mcl)) Settings.language = language.getText();
			else if (Settings.language != null) Settings.language = null;
			Maucros.reloadLanguage();
		}
	}
	
	private MintSlider.Format blinkFormat = new MintSlider.Format() {
		@Override
		public String format(int amount) {
			if (amount == 0) return I18n.format("conf.blink.safety") + ": " + I18n.format("conf.off");
			else return I18n.format("conf.blink.safety") + ": " + amount + " " + I18n.format("conf.blink.safety.level");
		}
	};
	
	private MintSlider.Format jumpHeightFormat = new MintSlider.Format() {
		@Override
		public String format(int amount) {
			if (amount == 0) return I18n.format("conf.amov.jumpheight") + ": " + I18n.format("conf.amov.jumpheight.relative");
			else return I18n.format("conf.amov.jumpheight") + ": " + amount;
		}
	};
	
	private MintSlider.Format flcFormat = new MintSlider.Format() {
		@Override
		public String format(int amount) {
			if (amount == 0) return I18n.format("conf.log.flushlinecount") + ": " + I18n.format("conf.log.flushlinecount.off");
			else return I18n.format("conf.log.flushlinecount") + ": " + amount + " " + I18n.format("conf.log.flushlinecount.on");
		}
	};
}
