package net.maunium.Maucros.Gui.Widgets;

import org.lwjgl.input.Keyboard;

import com.mcf.davidee.guilib.core.Container;
import com.mcf.davidee.guilib.core.Widget;
import com.mcf.davidee.guilib.vanilla.ScrollbarVanilla;

public class KeyHandlingContainer extends Container {
	public KeyHandlingContainer(ScrollbarVanilla sb, int i, int j) {
		super(sb, i, j);
	}
	
	public KeyHandlingContainer(){
		super();
	}

	@Override
	public boolean keyTyped(char c, int code) {
		for (Widget w : widgets)
			if (w.keyTyped(c, code)) return true;
		
		boolean handled = (focusIndex != -1) ? focusList.get(focusIndex).keyTyped(c, code) : false;
		if (!handled) {
			switch (code) {
				case Keyboard.KEY_UP:
					shift(-1);
					handled = true;
					break;
				case Keyboard.KEY_DOWN:
					shift(1);
					handled = true;
					break;
				case Keyboard.KEY_TAB:
					shiftFocusToNext();
					handled = true;
					break;
			}
		}
		return handled;
	}
}
