package net.maunium.Maucros.KeyMaucros.Commands;

import net.maunium.Maucros.Maucros;

import net.minecraft.client.Minecraft;
import net.minecraft.client.settings.KeyBinding;

public class CommandForward implements MaucroCommand {
	
	@Override
	public String getOwner() {
		return "Maucros";
	}
	
	@Override
	public String getName() {
		return "Forward";
	}
	
	@Override
	@SuppressWarnings("deprecation")
	public void execute(String label, String[] args) {
		if (args.length > 0) {
			final int time;
			try {
				time = Integer.parseInt(args[0]);
			} catch (NumberFormatException e) {
				Maucros.printChatError("The MaucroCommand Move takes one integer.");
				return;
			}
			new Thread() {
				@Override
				public void run() {
					KeyBinding.setKeyBindState(Minecraft.getMinecraft().gameSettings.keyBindForward.getKeyCode(), true);
					try {
						Thread.sleep(time);
					} catch (InterruptedException e) {
						e.printStackTrace();
					}
					KeyBinding.setKeyBindState(Minecraft.getMinecraft().gameSettings.keyBindForward.getKeyCode(), false);
				}
			}.start();
		} else Maucros.printChatError("The MaucroCommand Move takes one integer.");
	}
	
}
